import UIKit

// Copyright 2018 - Dave Lyon and Traboule Software

public class ConicGradientView: UIView {

    override public class var layerClass: AnyClass {
        return CAGradientLayer.self
    }

    private var gradientLayer: CAGradientLayer {
        return self.layer as! CAGradientLayer
    }

    public var colors: [UIColor]? {
        didSet {
            gradientLayer.colors = colors?.map { $0.cgColor }
        }
    }

    override public init(frame: CGRect) {
        super.init(frame: frame)
        configureGradientLayer()
    }

    required public init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        configureGradientLayer()
    }

    func configureGradientLayer() {
        gradientLayer.type = .conic
        gradientLayer.startPoint = CGPoint(x: 0.45, y: 0.45)
        gradientLayer.endPoint = CGPoint(x: 0.75, y: 1)
    }

    override public func tintColorDidChange() {
        super.tintColorDidChange()
        switch tintAdjustmentMode {
        case .dimmed:
            gradientLayer.colors = self.colors?.map { $0.grayscale.cgColor }
        default:
            gradientLayer.colors = self.colors?.map { $0.cgColor }
        }
    }
}

